#ifndef ALBENTABLE_H
#define ALBENTABLE_H

#include <QList>
#include <QMainWindow>
#include <QString>
#include <QTableWidgetItem>

#include "album.h"

namespace Ui {
	class AlbenTable;
}

class AlbenTable : public QMainWindow
{
		Q_OBJECT

	public:
		explicit AlbenTable(QWidget *parent = nullptr);
		~AlbenTable();

	protected:
		void showEvent(QShowEvent *ev);

	private slots:
		void addEntry();
		void changeEntry();
		void changeView();
		void deleteEntry();
		void searchCriterionChanged();
		void selectedDataChanged(QTableWidgetItem *current, QTableWidgetItem *previous);
		void viewEntry();
		void windowLoaded();
		void showOnlineSearch();

	private:
		/**
		 * @brief The UI
		 */
		Ui::AlbenTable *ui;

		/**
		 * @brief the database-table to look in
		 */
		const QString TABLE = "Albums";

		/**
		 * @brief the default sorting creteria
		 */
		const QString SORTING_CRETERIA = "Interpret, Title";

		void deleteEntry(QString ean);
		void disableButtons();
		void enableButtons();
		void output(QList<Album*> *albums);
		void search(QMap<QString, QString> *searchFilter = nullptr);
		void showAllEntrys();
};

#endif // ALBENTABLE_H
