#ifndef DATAWORKER_H
#define DATAWORKER_H

#include <QString>
#include <QList>
#include <QVector>

#include "album.h"
#include "smallalbum.h"
#include "smalltitle.h"
#include "title.h"

/**
 * @brief class for make communication with database easier
 */
class DataWorker
{

	private:
		static QString createSearchCriterionForAlbum(int index);
		static QString createSearchCriterionForTitle(int index);

	public:
		static Album* getAlbum(QVector<QString> *entry);
		static SmallAlbum* getSmallAlbum(QVector<QString> *entry);

		static Title* getTitle(QVector<QString> *entry);
		static SmallTitle* getSmallTitle(QVector<QString> *entry);

		static QList<Album*>* getAlbums(QList<QVector<QString>*> *entries);
		static QList<SmallAlbum*>* getSmallAlbums(QList<QVector<QString>*> *entries);

		static QList<Title*>* getTitles(QList<QVector<QString>*> *entries);
		static QList<SmallTitle*>* getSmallTitles(QList<QVector<QString>*> *entries);

		static QMap<QString,QString>& getAlbumMapForDatabase(Album *album);
		static QMap<QString,QString>& getTitleMapForDatabase(Title *title);

		static QMap<QString,QString>* createSearchFilterForAlbum(int index1, int index2, QString text1, QString text2);
		static QMap<QString,QString>* createSearchFilterForTitle(int index1, int index2, QString text1, QString text2);
};

#endif // DATAWORKER_H
