#ifndef SERVER_H
#define SERVER_H

#include <SqlWorker/DatabaseWorker.hpp>
#include <QString>

/**
 * @brief This class contains all information necessary for the connection with the server
 */
class Server
{
	public:
		SqlWorker::DatabaseWorker *database;
		const static Server& getInstance();

	private:
		Server(QString &serverAddress, QString &database, QString &username, QString &password);
		~Server();
		static bool tryCreateInstance();
		static void showCredentialError();

		static bool allOk;
		const static Server *instance;
};

#endif // SERVER_H
