#ifndef TITLEDETAIL_H
#define TITLEDETAIL_H

#include "detailmodi.h"
#include "title.h"

#include <QMainWindow>
#include <QSettings>
#include <QString>
#include <QVector>

namespace Ui {
	class TitleDetail;
}

class TitleDetail : public QMainWindow
{
		Q_OBJECT

	public:
		explicit TitleDetail(QWidget *parent = nullptr);
		~TitleDetail();
		void load(short id, DetailModi mode);

	protected:
		void closeEvent(QCloseEvent *event);

	private slots:
		void addEntry();
		void btnBackClick();
		void changeEntry();

	private:
		/**
		 * @brief link to the user interface
		 */
		Ui::TitleDetail *ui;

		/**
		 * @brief the table to look in
		 */
		const QString TABLE = "Titles";

		/**
		 * @brief primary key of @see TABLE
		 */
		const QString PRIMARY_KEY = "ID";

		/**
		 * @brief columns in the order in wich they can be find in @see TABLE
		 */
		const QVector<QString> COLUMNS{ "ID", "Title", "Interpret", "Album", "Genre", "Year", "Owner", "Format" };

		QSettings settings;

		void disableAll();
		void enableAll();
		void getEntry(int id);
		void output(Title *title);
		void setIdReadOnly();
		bool tryCreateDatabaseEntry(QMap<QString,QString> &databaseEntry);
};

#endif // TITLEDETAIL_H
