#ifndef TITLETABLE_H
#define TITLETABLE_H

#include <QList>
#include <QMainWindow>
#include <QString>
#include <QTableWidgetItem>

#include "title.h"

namespace Ui {
	class TitleTable;
}

class TitleTable : public QMainWindow
{
		Q_OBJECT

	public:
		explicit TitleTable(QWidget *parent = nullptr);
		~TitleTable();

	protected:
		void showEvent(QShowEvent *ev);

	private slots:
		void addEntry();
		void changeEntry();
		void changeView();
		void deleteEntry();
		void searchCriterionChanged();
		void selectedDataChanged(QTableWidgetItem *current, QTableWidgetItem *previous);
		void viewEntry();
		void windowLoaded();

	private:
		/**
		 * @brief The user interface
		 */
		Ui::TitleTable *ui;

		/**
		 * @brief the database-table to look in
		 */
		const QString TABLE = "Titles";

		/**
		 * @brief the default sorting creteria
		 */
		const QString SORTING_CRETERIA = "Interpret, Album, Title";

		void deleteEntry(int id);
		void disableButtons();
		void enableButtons();
		void output(QList<Title*> *titles);
		void search(QMap<QString,QString> *filter = nullptr);
};

#endif // TITLETABLE_H
