#include "splashscreen.h"
#include "ui_splashscreen.h"

#include "albenlist.h"
#include "version.h"

#include <QDate>

SplashScreen::SplashScreen(QWidget *parent) :
	QMainWindow(parent),
	ui(new Ui::SplashScreen)
{
	ui->setupUi(this);
	ui->lblVersion->setText(PROJECT_VER);
	QString productNameDisplayOpen = "<html><head/><body><p align=\"center\"><br/></p><p align=\"center\"><img src=\":/Musicsystem/musicdatabase_128x128-32.png\"/></p><p><br/><span style=\" font-size:18pt;\">";
	QString productNameDisplayClose = "</span></p></body></html>";
	QString productNameDisplay = QApplication::tr("%1Musicsystem%2").arg(productNameDisplayOpen, productNameDisplayClose);
	ui->lblProductName->setText(productNameDisplay);
	ui->lblCopyright->setText(QString("Copyright © ") + AUTHOR + " " + QString::number(QDate::currentDate().year()));
	timer = new QTimer();
}

SplashScreen::~SplashScreen()
{
	delete ui;
}

void SplashScreen::loadNextWindow()
{
	timer->stop();
	disconnect(timer, &QTimer::timeout, 0, 0);
	delete timer;
	AlbenList *albenList = new AlbenList();
	albenList->setAttribute(Qt::WA_DeleteOnClose);
	albenList->show();
	close();
}

void SplashScreen::showEvent(QShowEvent *ev)
{
	QMainWindow::showEvent(ev);
	QMetaObject::invokeMethod(this, "windowLoaded", Qt::ConnectionType::QueuedConnection);
}

void SplashScreen::windowLoaded()
{
	connect(timer, &QTimer::timeout, this, &SplashScreen::loadNextWindow);
	timer->start(3000);
}
